#!/bin/sh

# environment
ROOT_PATH=/usr/local/codetyphon
TYPHON_PATH=${ROOT_PATH}/typhon
TYPHON_BIN_LIB=${ROOT_PATH}/binLibraries
FPC=${ROOT_PATH}/fpc/fpc64/bin/x86_64-linux/fpc

if [ ! -d "out" ]; then
	mkdir "out"
fi
if [ ! -d "build" ]; then
	mkdir "build"
fi

# build for android
__compile() {
	CPU=$1
	LIB=$2
	EABI=$3
	if [ ! -d "out/${EABI}" ]; then 
		mkdir out/${EABI}
	fi
	${FPC} -B -Tandroid -P${CPU} \
	-MObjFPC -Scghi -Cg -O1 -g -gl -l -vewnhibq \
	-Fl${TYPHON_BIN_LIB}/android-5.0.x-api27-${LIB} \
	-Finetport -Funetport \
	-Fu${TYPHON_PATH}/packager/units/${CPU}-android \
	-Fu. \
	-Fibuild -FUbuild \
	-oout/${EABI}/libcoder.so \
	coder.lpr
}

__compile "arm" "arm" "armeabi"
__compile "arm" "arm" "armeabi-v7a"
__compile "i386" "i386" "x86"
__compile "mipsel" "mips" "mips"

# done
echo "DONE!"
