{.$DEFINE DEBUG}

{$IFDEF DEBUG}program{$ELSE}library{$ENDIF} coder;

{$mode objfpc}{$H+}

uses
  {$IFNDEF WINDOWS}cthreads,{$ENDIF}
  Classes, sysutils, untOperater, JNI2
  {$IFDEF DEBUG}, IniFiles{$ENDIF};

function runProject(AProjPath: PChar; ATmpPath: PChar; AEmail: PChar; AProjName: PChar; AMainFile: PChar; ACodeType: Integer): PChar; cdecl;
var
  ret: string;
begin
  ret := _serverCompileRun(string(ATmpPath), string(AEmail), string(AProjName), string(AMainFile), ACodeType);
  Result := StrAlloc(ret.Length + 1);
  strcopy(Result, PChar(ret));
end;

procedure setServerUrl(AUrl: PChar); cdecl;
begin
  URL_CODER:= string(AUrl) + '/coding';
  URL_ACCOUNT:= string(AUrl) + '/account';
  URL_SYNC:= string(AUrl) + '/sync';
end;

function userRegister(AAccount: PChar; APassword: PChar; AEmail: PChar; ANickname: PChar): PChar; cdecl;
var
  ret: string;
begin
  ret := _userRegister(string(AAccount), string(APassword), string(AEmail), string(ANickname));
  Result := StrAlloc(ret.Length + 1);
  strcopy(Result, PChar(ret));
end;

function userLogin(AAccount: PChar; APassword: PChar): PChar; cdecl;
var
  ret: string;
begin
  ret := _userLogin(string(AAccount), string(APassword));
  Result := StrAlloc(ret.Length + 1);
  strcopy(Result, PChar(ret));
end;

function userInfo(AGuid: PChar): PChar; cdecl;
var
  ret: string;
begin
  ret := _userInfo(string(AGuid));
  Result := StrAlloc(ret.Length + 1);
  strcopy(Result, PChar(ret));
end;

function userPerm(AGuid: PChar): PChar; cdecl;
var
  ret: string;
begin
  ret := _userPerm(string(AGuid));
  Result := StrAlloc(ret.Length + 1);
  strcopy(Result, PChar(ret));
end;

function userChangePassword(AGuid: PChar; AOldPAss: PChar; ANewPass: PChar): PChar; cdecl;
var
  ret: string;
begin
  ret := _userChangePassword(string(AGuid), string(AOldPAss), string(ANewPass));
  Result := StrAlloc(ret.Length + 1);
  strcopy(Result, PChar(ret));
end;

function userChangeNickname(AGuid: PChar; ANickname: PChar): PChar; cdecl;
var
  ret: string;
begin
  ret := _userChangeNickname(string(AGuid), string(ANickname));
  Result := StrAlloc(ret.Length + 1);
  strcopy(Result, PChar(ret));
end;

function userChangeEmail(AGuid: PChar; AEmail: PChar): PChar; cdecl;
var
  ret: string;
begin
  ret := _userChangeEmail(string(AGuid), string(AEmail));
  Result := StrAlloc(ret.Length + 1);
  strcopy(Result, PChar(ret));
end;

function syncList(AGuid: PChar): PChar; cdecl;
var
  ret: string;
begin
  ret := _syncList(string(AGuid));
  Result := StrAlloc(ret.Length + 1);
  strcopy(Result, PChar(ret));
end;

function syncDownload(AGuid: PChar; AProjName: PChar): PChar; cdecl;
var
  ret: string;
begin
  ret := _syncDownload(string(AGuid), string(AProjName));
  Result := StrAlloc(ret.Length + 1);
  strcopy(Result, PChar(ret));
end;

function syncUpload(AProjPath: PChar; ATmpPath: PChar; AGuid: PChar; AProjName: PChar): PChar; cdecl;
var
  ret: string;
begin
  ret := _syncUpload(string(AProjPath), string(ATmpPath), string(AGuid), string(AProjName));
  Result := StrAlloc(ret.Length + 1);
  strcopy(Result, PChar(ret));
end;

function syncDelete(AGuid: PChar; AProjName: PChar): PChar; cdecl;
var
  ret: string;
begin
  ret := _syncDelete(string(AGuid), string(AProjName));
  Result := StrAlloc(ret.Length + 1);
  strcopy(Result, PChar(ret));
end;

function Java_com_hujiang_coding_CoderJNI_runProject(env: PJNIEnv; obj: jobject; projPath: jstring; tmpPath: jstring; email: jstring; projName: jstring; mainFile: jstring; codeType: jint): jstring; cdecl;
var
  projPathStr: string;
  tmpPathStr: string;
  emailStr: string;
  projNameStr: string;
  mainFileStr: string;
  ret: string;
  jexit: jstring;
begin
  projPathStr:= TJNIEnv.JStringToString(env, projPath);
  tmpPathStr:= TJNIEnv.JStringToString(env, tmpPath);
  emailStr:= TJNIEnv.JStringToString(env, email);
  projNameStr:= TJNIEnv.JStringToString(env, projName);
  mainFileStr:= TJNIEnv.JStringToString(env, mainFile);
  ret := _serverCompileRun(tmpPathStr, emailStr, projNameStr, mainFileStr, codeType);
  try
    jexit:= TJNIEnv.StringToJString(env, ret);
  except
    jexit:= TJNIEnv.StringToJString(env, '');
  end;
  Exit(jexit);
end;

procedure Java_com_hujiang_coding_CoderJNI_setServerUrl(env: PJNIEnv; obj: jobject; url: jstring); cdecl;
var
  base: string;
begin
  base := TJNIEnv.JStringToString(env, url);
  URL_CODER:= base + '/coding';
  URL_ACCOUNT:= base + '/account';
  URL_SYNC:= base + '/sync';
end;

function Java_com_hujiang_coding_CoderJNI_userRegister(env: PJNIEnv; obj: jobject; account: jstring; password: jstring; email: jstring; nickname: jstring): jstring; cdecl;
var
  ret: string;
begin
  ret := _userRegister(
    TJNIEnv.JStringToString(env, account),
    TJNIEnv.JStringToString(env, password),
    TJNIEnv.JStringToString(env, email),
    TJNIEnv.JStringToString(env, nickname)
  );
  Exit(TJNIEnv.StringToJString(env, ret));
end;

function Java_com_hujiang_coding_CoderJNI_userLogin(env: PJNIEnv; obj: jobject; account: jstring; password: jstring): jstring; cdecl;
var
  ret: string;
begin
  ret := _userLogin(
    TJNIEnv.JStringToString(env, account),
    TJNIEnv.JStringToString(env, password)
  );
  Exit(TJNIEnv.StringToJString(env, ret));
end;

function Java_com_hujiang_coding_CoderJNI_userInfo(env: PJNIEnv; obj: jobject; guid: jstring): jstring; cdecl;
var
  ret: string;
begin
  ret := _userInfo(TJNIEnv.JStringToString(env, guid));
  Exit(TJNIEnv.StringToJString(env, ret));
end;

function Java_com_hujiang_coding_CoderJNI_userPerm(env: PJNIEnv; obj: jobject; guid: jstring): jstring; cdecl;
var
  ret: string;
begin
  ret := _userPerm(TJNIEnv.JStringToString(env, guid));
  Exit(TJNIEnv.StringToJString(env, ret));
end;

function Java_com_hujiang_coding_CoderJNI_userChangePassword(env: PJNIEnv; obj: jobject; guid: jstring; oldPass: jstring; newPass: jstring): jstring; cdecl;
var
  ret: string;
begin
  ret := _userChangePassword(
    TJNIEnv.JStringToString(env, guid),
    TJNIEnv.JStringToString(env, oldPass),
    TJNIEnv.JStringToString(env, newPass)
  );
  Exit(TJNIEnv.StringToJString(env, ret));
end;

function Java_com_hujiang_coding_CoderJNI_userChangeNickname(env: PJNIEnv; obj: jobject; guid: jstring; nickname: jstring): jstring; cdecl;
var
  ret: string;
begin
  ret := _userChangeNickname(
    TJNIEnv.JStringToString(env, guid),
    TJNIEnv.JStringToString(env, nickname)
  );
  Exit(TJNIEnv.StringToJString(env, ret));
end;

function Java_com_hujiang_coding_CoderJNI_userChangeEmail(env: PJNIEnv; obj: jobject; guid: jstring; email: jstring): jstring; cdecl;
var
  ret: string;
begin
  ret := _userChangeEmail(
    TJNIEnv.JStringToString(env, guid),
    TJNIEnv.JStringToString(env, email)
  );
  Exit(TJNIEnv.StringToJString(env, ret));
end;

function Java_com_hujiang_coding_CoderJNI_syncList(env: PJNIEnv; obj: jobject; guid: jstring): jstring; cdecl;
var
  ret: string;
begin
  ret := _syncList(TJNIEnv.JStringToString(env, guid));
  Exit(TJNIEnv.StringToJString(env, ret));
end;

function Java_com_hujiang_coding_CoderJNI_syncDownload(env: PJNIEnv; obj: jobject; guid: jstring; projName: jstring): jstring; cdecl;
var
  ret: string;
begin
  ret := _syncDownload(
    TJNIEnv.JStringToString(env, guid),
    TJNIEnv.JStringToString(env, projName)
  );
  Exit(TJNIEnv.StringToJString(env, ret));
end;

function Java_com_hujiang_coding_CoderJNI_syncUpload(env: PJNIEnv; obj: jobject; projPath: jstring; tmpPath: jstring; guid: jstring; projName: jstring): jstring; cdecl;
var
  ret: string;
begin
  ret := _syncUpload(
    TJNIEnv.JStringToString(env, projPath),
    TJNIEnv.JStringToString(env, tmpPath),
    TJNIEnv.JStringToString(env, guid),
    TJNIEnv.JStringToString(env, projName)
  );
  Exit(TJNIEnv.StringToJString(env, ret));
end;

function Java_com_hujiang_coding_CoderJNI_syncDelete(env: PJNIEnv; obj: jobject; guid: jstring; projName: jstring): jstring; cdecl;
var
  ret: string;
begin
  ret := _syncDelete(
    TJNIEnv.JStringToString(env, guid),
    TJNIEnv.JStringToString(env, projName)
  );
  Exit(TJNIEnv.StringToJString(env, ret));
end;


{$IFNDEF DEBUG}
exports
  runProject,
  setServerUrl,
  userRegister,
  userLogin,
  userInfo,
  userPerm,
  userChangePassword,
  userChangeNickname,
  userChangeEmail,
  syncList,
  syncDownload,
  syncUpload,
  syncDelete,
  Java_com_hujiang_coding_CoderJNI_runProject,
  Java_com_hujiang_coding_CoderJNI_setServerUrl,
  Java_com_hujiang_coding_CoderJNI_userRegister,
  Java_com_hujiang_coding_CoderJNI_userLogin,
  Java_com_hujiang_coding_CoderJNI_userInfo,
  Java_com_hujiang_coding_CoderJNI_userPerm,
  Java_com_hujiang_coding_CoderJNI_userChangePassword,
  Java_com_hujiang_coding_CoderJNI_userChangeNickname,
  Java_com_hujiang_coding_CoderJNI_userChangeEmail,
  Java_com_hujiang_coding_CoderJNI_syncList,
  Java_com_hujiang_coding_CoderJNI_syncDownload,
  Java_com_hujiang_coding_CoderJNI_syncUpload,
  Java_com_hujiang_coding_CoderJNI_syncDelete;
{$ENDIF}

{$IFDEF DEBUG}
procedure writeHelp();
begin
  WriteLn('usage: coder <config file> <tmp path>');
  WriteLn('');
  WriteLn('  config file must be an INI file and contains the keys:');
  WriteLn('    * [CONFIG]');
  WriteLn('    - EMAIL');
  WriteLn('    - PROJECT_PATH');
  WriteLn('    - PROJECT_NAME');
  WriteLn('    - MAIN_FILE');
  WriteLn('    - CODE_TYPE');
  WriteLn('');
end;

const
  SEC_CONFIG = 'CONFIG';
  KEY_EMAIL = 'EMAIL';
  KEY_PROJECT_PATH = 'PROJECT_PATH';
  KEY_PROJECT_NAME = 'PROJECT_NAME';
  KEY_MAIN_FILE = 'MAIN_FILE';
  KEY_CODE_TYPE = 'CODE_TYPE';

var
  cfgPath: string;
  projPath: string;
  tmpPath: string;
  email: string;
  projName: string;
  mainFile: string;
  codeType: Integer;
  ret: string;
{$ENDIF}
begin
  {$IFDEF DEBUG}
  cfgPath:= ParamStr(1);
  tmpPath:= ParamStr(2);

  if (cfgPath = '') then begin
    writeHelp();
    Exit;
  end;

  if (tmpPath = '') then tmpPath:= ExtractFilePath(ParamStr(0));
  with TIniFile.Create(cfgPath) do begin
    projPath:= ReadString(SEC_CONFIG, KEY_PROJECT_PATH, '');
    email:= ReadString(SEC_CONFIG, KEY_EMAIL, '');
    projName:= ReadString(SEC_CONFIG, KEY_PROJECT_NAME, '');
    mainFile:= ReadString(SEC_CONFIG, KEY_MAIN_FILE, '');
    codeType:= ReadInteger(SEC_CONFIG, KEY_CODE_TYPE, 0);
    Free;
  end;
  ret := string(runProject(PChar(projPath), PChar(tmpPath), PChar(email), PChar(projName), PChar(mainFile), codeType));
  WriteLn(ret);
  {$ENDIF}
end.


